package operation

import (
	"shylinux.com/x/ice"
	"shylinux.com/x/icebergs/base/aaa"
	"shylinux.com/x/icebergs/base/web"
	kit "shylinux.com/x/toolkits"

	"shylinux.com/x/operation/src/operation/model"
)

type studio struct {
	Tables
	cluster Cluster
	list    string `name:"list list"`
	gateway string `name:"gateway" role:"void"`
	project string `name:"project" role:"void"`
	product string `name:"product" role:"void"`
}

func (s studio) List(m *ice.Message, arg ...string) {
	m.Cmdy(s.PrefixPortal(m)).Action().Display("")
}
func (s studio) Gateway(m *ice.Message, arg ...string) {
	if len(arg) < 3 {
		m.Cmdy(m.Prefix(m.ActionKey()), arg[0])
	} else {
		m.Cmdy(web.SPACE, s.space(m, arg, model.CLUSTER_SPACE, model.SPACE), arg[2:])
	}
}
func (s studio) Project(m *ice.Message, arg ...string) {
	if len(arg) < 3 {
		m.Cmdy(m.Prefix(m.ActionKey()), s.Select, model.CLOUD_UID, arg[0], model.GATEWAY_UID, arg[1])
	} else {
		m.Cmdy(web.SPACE, s.space(m, arg, model.CLUSTER_SPACE, model.GATEWAY_SPACE, model.NAME), arg[2:])
	}
}
func (s studio) Product(m *ice.Message, arg ...string) {
	if len(arg) < 3 {
		m.Cmdy(m.Prefix(m.ActionKey()), s.Select, model.CLOUD_UID, arg[0], model.PROJECT_UID, arg[1])
	} else {
		m.Cmdy(web.SPACE, s.space(m, arg, model.CLUSTER_SPACE, model.GATEWAY_SPACE, model.PROJECT_NAME), arg[2:])
	}
}

func init() { ice.TeamCtxCmd(studio{}) }

func (s studio) space(m *ice.Message, arg []string, args ...string) string {
	if s.UserPlaceRole(m); s.IsWorker(m) {
		m.Option(ice.MSG_USERROLE, aaa.TECH)
	}
	space := []ice.Any{}
	msg := m.Cmd(m.Prefix(m.ActionKey()), arg[0], arg[1])
	kit.For(args, func(key string) { space = append(space, msg.Append(key)) })
	return m.Option(ice.MSG_USERPOD, kit.Keys(space...))
}
