package operation

import (
	"shylinux.com/x/ice"
	kit "shylinux.com/x/toolkits"

	"shylinux.com/x/operation/src/operation/model"
)

type template struct {
	Table
	order   string `data:"2"`
	fields  string `data:"name,info,title,icons,repos,binary,template_status"`
	create  string `name:"create name* info title icons repos* binary*"`
	modify  string `name:"modify name* info title icons repos* binary*" style:"danger"`
	install string `name:"install name* gateway_uid*" style:"notice" role:"worker"`
}

func (s template) Create(m *ice.Message, arg ...string) {
	s.Insert(m, arg...)
}
func (s template) List(m *ice.Message, arg ...string) {
	if m.IsTech() {
		if len(arg) < 2 {
			s.Select(m)
		} else {
			s.SelectDetail(m, model.UID, arg[1])
		}
		m.Table(func(value ice.Maps) {
			if TemplateStatus(kit.Int(value[model.TEMPLATE_STATUS])) == TemplateOffline {
				m.PushButton(s.Online, s.Modify)
			} else {
				m.PushButton(s.Install, s.Offline, s.Modify)
			}
		})
		if m.Length() == 0 {
			s.Button(m, "")
		}
	} else {
		if len(arg) < 2 {
			s.Select(m, model.STATUS, kit.Format(TemplateOnline))
		} else {
			s.SelectDetail(m, model.UID, arg[1])
		}
		if m.PushAction(s.Install).Action(); m.Length() == 0 {
			m.Echo("请等待「平台管理员」创建模板")
		}
	}
	m.Display("")
}
func (s template) Install(m *ice.Message, arg ...string) {
	msg := m.Cmd(Gateway{}, m.Option(model.CLOUD_UID), m.Option(model.GATEWAY_UID))
	m.Option(model.SPACE, kit.Keys(msg.Append(model.CLUSTER_SPACE), msg.Append(model.SPACE)))
	m.Cmdy(project{}, s.Create, m.OptionSimple("name,icons,repos,binary"))
}
func (s template) Offline(m *ice.Message, arg ...string) {
	s.Update(m, []string{model.STATUS, kit.Format(TemplateOffline)})
	s.RecordEventWithName(m, "")
}
func (s template) Online(m *ice.Message, arg ...string) {
	s.Update(m, []string{model.STATUS, kit.Format(TemplateOnline)})
	s.RecordEventWithName(m, "")
}
func (s template) Modify(m *ice.Message, arg ...string) {
	s.Update(m, arg)
	s.RecordEventWithName(m, "")
}

func init() { ice.TeamCtxCmd(template{}) }

type TemplateStatus int

const (
	TemplateOffline TemplateStatus = iota
	TemplateOnline
)

var TemplateStatusList = map[TemplateStatus]string{
	TemplateOffline: "offline",
	TemplateOnline:  "online",
}

func (s TemplateStatus) String() string { return TemplateStatusList[s] }
