package storage

import (
	"shylinux.com/x/ice"
	kit "shylinux.com/x/toolkits"

	"shylinux.com/x/enterprise/src/guanlixitong"
	"shylinux.com/x/operation/src/storage/model"
)

type Table struct {
	guanlixitong.Table
	list string `name:"list storage_uid uid auto" role:"void"`
}

func (s Table) Inputs(m *ice.Message, arg ...string) {
	switch arg[0] {
	case model.USER_STORAGE_ROLE:
		s.InputsListRole(m, UserStorageRoleList, arg...)
	case model.STORAGE_TYPE:
		s.InputsList(m, StorageTypeList, arg...)
	default:
		s.Table.Inputs(m, arg...)
	}
}
func (s Table) RewriteAppend(m *ice.Message, arg ...string) *ice.Message {
	m.RewriteAppend(func(value, key string, index int) string {
		switch key {
		case model.USER_STORAGE_ROLE:
			value = UserStorageRole(kit.Int(value)).String()
		case model.STORAGE_TYPE:
			value = StorageType(kit.Int(value)).String()
		case model.FILE_TYPE:
			value = FileType(kit.Int(value)).String()
		}
		return value
	})
	return s.Table.RewriteAppend(m)
}

type Tables struct{ Table }

func (s Tables) BeforeMigrate(m *ice.Message, arg ...string) {}
